/*************************************************************************/
/* SSCANF.C - This program demonstrates the problem concerning the %n    */
/*   format control option in the sscanf() function as documented in the */
/*   letter to the editor in the May 1991 issue of Inside Microsoft C.   */
/*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char workstr[256];

#define FIXSTR(s) strcat(strcpy(workstr,s)," ")

int main(void)
{
    char *str1 = "7777.77 ";
    char *str2 = "666.66";
    char *str3 = "55.55";
    double x;
    int count;
    int rval;

    /*----The 2nd and 3rd cases below demonstrate the problem--------------*/
    count = -1;
    rval = sscanf( str1, "%7lf%n", &x, &count);
    printf("rval=%d string='%s'  double=%.2f  count=%i\n",rval,str1,x,count);

    count = -1;
    rval = sscanf( str2, "%6lf%n", &x, &count);
    printf("rval=%d string='%s'  double=%.2f  count=%i\n",rval,str2,x,count);

    count = -1;
    rval = sscanf( str3, "%5lf%n", &x, &count);
    printf("rval=%d string='%s'  double=%.2f  count=%i\n",rval,str3,x,count);

    printf( "\n" );

    /*----These three cases show how FIXSTR() takes care of it-------------*/
    count = -1;
    rval = sscanf(FIXSTR(str1), "%7lf%n", &x, &count);
    printf("rval=%d string='%s'  double=%.2f  count=%i\n",rval,str1,x,count);

    count = -1;
    rval = sscanf(FIXSTR(str2), "%6lf%n", &x, &count);
    printf("rval=%d string='%s'  double=%.2f  count=%i\n",rval,str2,x,count);

    count = -1;
    rval = sscanf(FIXSTR(str3), "%5lf%n", &x, &count);
    printf("rval=%d string='%s'  double=%.2f  count=%i\n",rval,str3,x,count);

}
